module mFlashMem(adr,dat);
	input [8:0] adr;
	output [11:0] dat;
	reg [11:0] romdat;
	assign dat=romdat;
	always @(adr) begin
		case (adr)
        12'h00 : romdat=12'h0A12;
        12'h01 : romdat=12'h0C08;
        12'h02 : romdat=12'h0006;
        12'h03 : romdat=12'h0CC7;
        12'h04 : romdat=12'h0002;
        12'h05 : romdat=12'h0066;
        12'h06 : romdat=12'h0069;
        12'h07 : romdat=12'h0800;
        12'h08 : romdat=12'h0C0D;
        12'h09 : romdat=12'h0028;
        12'h0A : romdat=12'h0C01;
        12'h0B : romdat=12'h0021;
        12'h0C : romdat=12'h0201;
        12'h0D : romdat=12'h0743;
        12'h0E : romdat=12'h0A0C;
        12'h0F : romdat=12'h02E8;
        12'h10 : romdat=12'h0A0A;
        12'h11 : romdat=12'h0800;
        12'h12 : romdat=12'h0901;
        12'h13 : romdat=12'h0249;
        12'h14 : romdat=12'h0026;
        12'h15 : romdat=12'h0908;
        12'h16 : romdat=12'h0666;
        12'h17 : romdat=12'h0A1A;
        12'h18 : romdat=12'h0289;
        12'h19 : romdat=12'h0A1B;
        12'h1A : romdat=12'h00C9;
        12'h1B : romdat=12'h0E07;
        12'h1C : romdat=12'h0029;
        12'h1D : romdat=12'h0A13;
        default : romdat=12'h0fff;
		endcase
	end
endmodule

