`timescale 1 ps / 1 ps

module mCmdDecode2(
	cmd,
	addwf, andwf, clrf, clrw, comf, decf, decfsz, incf, incfsz, iorwf,
	movf,  movwf, rlf,  rrf,  subwf,swapf,xorwf,  bcf,  bsf,
	btfsc, btfss, andlw,call, goto, iorlw, movlw, retlw, xorlw, 
    option,clrwdt, tris, nop
) ;

	input [11:0] cmd ;
	
	output
	addwf, andwf, clrf, clrw, comf, decf, decfsz, incf, incfsz, iorwf,
	movf,  movwf, rlf,  rrf,  subwf,swapf,xorwf,  bcf,  bsf,
	btfsc, btfss, andlw,call, goto, iorlw, movlw, retlw, xorlw, 
    option,clrwdt, tris, nop ;

	assign addwf  = (cmd[11:6]==6'b0001_11)  ? 1'b1: 1'b0;
	assign andwf  = (cmd[11:6]==6'b0001_01)  ? 1'b1: 1'b0;
	assign clrf   = (cmd[11:5]==7'b0000_011) ? 1'b1: 1'b0;
	assign clrw   = (cmd==12'b0000_0100_0000)? 1'b1: 1'b0;
	assign comf   = (cmd[11:6]==6'b0010_01)  ? 1'b1: 1'b0;
	assign decf   = (cmd[11:6]==6'b0000_11)  ? 1'b1: 1'b0;
	assign decfsz = (cmd[11:6]==6'b0010_11)  ? 1'b1: 1'b0;
	assign incf   = (cmd[11:6]==6'b0010_10)  ? 1'b1: 1'b0;
	assign incfsz = (cmd[11:6]==6'b0011_11)  ? 1'b1: 1'b0;
	assign iorwf  = (cmd[11:6]==6'b0001_00)  ? 1'b1: 1'b0;
	assign movf   = (cmd[11:6]==6'b0010_00)  ? 1'b1: 1'b0;
	assign movwf  = (cmd[11:5]==7'b0000_001) ? 1'b1: 1'b0;
	assign rlf    = (cmd[11:6]==6'b0011_01)  ? 1'b1: 1'b0;
	assign rrf    = (cmd[11:6]==6'b0011_00)  ? 1'b1: 1'b0;
	assign subwf  = (cmd[11:6]==6'b0000_10)  ? 1'b1: 1'b0;
	assign swapf  = (cmd[11:6]==6'b0011_10)  ? 1'b1: 1'b0;
	assign xorwf  = (cmd[11:6]==6'b0001_10)  ? 1'b1: 1'b0;
	assign bcf    = (cmd[11:8]==4'b0100)  	? 1'b1: 1'b0;
	assign bsf    = (cmd[11:8]==4'b0101)	? 1'b1: 1'b0;
	assign btfsc  = (cmd[11:8]==4'b0110)	? 1'b1: 1'b0;
	assign btfss  = (cmd[11:8]==4'b0111)	? 1'b1: 1'b0;
	assign andlw  = (cmd[11:8]==4'b1110)	? 1'b1: 1'b0;
	assign call   = (cmd[11:8]==4'b1001)	? 1'b1: 1'b0;
	assign goto   = (cmd[11:9]==3'b101)		? 1'b1: 1'b0;
	assign iorlw  = (cmd[11:8]==4'b1101)	? 1'b1: 1'b0;
	assign movlw  = (cmd[11:8]==4'b1100)	? 1'b1: 1'b0;
	assign retlw  = (cmd[11:8]==4'b1000)	? 1'b1: 1'b0;
	assign xorlw  = (cmd[11:8]==4'b1111)	? 1'b1: 1'b0;
	assign option = (cmd==12'b0000_0000_0010) ? 1'b1: 1'b0;
	assign clrwdt = (cmd==12'b0000_0000_0100) ? 1'b1: 1'b0;
	assign tris   = (cmd==12'b0000_0000_011x) ? 1'b1: 1'b0;
	assign nop    = (cmd==12'b0000_0000_0000) ? 1'b1: 1'b0;
endmodule
