library verilog;
use verilog.vl_types.all;
entity mRegFile is
    port(
        reset           : in     vl_logic;
        clk             : in     vl_logic;
        Q               : in     vl_logic;
        fadr            : in     vl_logic_vector(4 downto 0);
        datin           : in     vl_logic_vector(7 downto 0);
        datout          : out    vl_logic_vector(7 downto 0);
        cin             : in     vl_logic;
        cout            : out    vl_logic;
        dc              : in     vl_logic;
        zf              : in     vl_logic;
        wr_cf           : in     vl_logic;
        wr_dc           : in     vl_logic;
        wr_zf           : in     vl_logic;
        wr_fr           : in     vl_logic;
        gp_in           : in     vl_logic_vector(7 downto 0);
        gp_out          : out    vl_logic_vector(7 downto 0);
        wr_tris         : in     vl_logic;
        tris_out        : out    vl_logic_vector(7 downto 0);
        pc_in           : in     vl_logic_vector(8 downto 0);
        pc_out          : out    vl_logic_vector(8 downto 0);
        wr_pc           : out    vl_logic;
        timer_in        : in     vl_logic_vector(7 downto 0);
        wr_tmr          : out    vl_logic;
        opt_out         : out    vl_logic_vector(7 downto 0);
        wr_opt          : in     vl_logic
    );
end mRegFile;
