;=======================================================================
;   Test Program for PIC16F508 Emulator
;   Instruction Test
;=======================================================================

	list      p=12F508
	#include <p12F508.inc>

	__CONFIG   _MCLRE_OFF & _CP_OFF & _WDT_OFF & _IntRC_OSC


;====== Variables ======================================================
WORK		EQU		0x08

;====== Program start ==================================================
	ORG		0x000             ; Start Address
	MOVLW	0xaa		;W=AA
	MOVWF	WORK		;W=AA,WORK=AA
	CLRW			;W=00
	MOVF	WORK,W	;W=AA
	ANDLW	0xf0		;W=A0
	IORLW	0x05		;W=A5
	XORLW	0x0f		;W=AA	
	INCF	WORK,W	;W=AB
	INCF	WORK,F	;W=AB,WORK=AB
	DECF	WORK,W	;W=AA
	DECF	WORK,F	;W=AA,WORK=AA
	COMF	WORK,W	;W=55
	CLRW			;W=0
	MOVLW	0xa0		;W=A0
	MOVWF	WORK		;W=A0,WORK=A0
	MOVLW	0x0a		;W=0A
	IORWF	WORK,W	;W=AA
	MOVWF	WORK		;W=AA
	RLF		WORK,W	;W=55,C=1
	MOVWF	WORK		;W=55,C=1
	RRF		WORK,W	;W=AA,C=1
	MOVLW	0x12		;W=12
	MOVWF	WORK		;W=12,WORK=12
	MOVLW	0x34		;W=34
	ADDWF	WORK,W	;W=46
	SUBWF	WORK,W	;W=CC
	MOVLW	0xA0		;W=A0
	MOVWF	WORK		;W=A0,WORK=A0
	MOVLW	0x50		;W=50
	ADDWF	WORK,W	;W=F0
	SWAPF	WORK,W	;W=0A
	BSF		WORK,6	;W=0A,WORK=E0
	MOVF	WORK,W	;W=E0
	BCF		WORK,5	;W=E0,WORK=C0
	MOVF	WORK,W	;W=C0
	MOVLW	0x1		;W=1
	MOVWF	WORK		;W=1,WORK=1
	DECFSZ	WORK,W	;W=1,WORK=0
	MOVLW	0xff		;W=0 ->OK, W=FF ->Error!
	MOVLW	0xff		;W=FF
	MOVWF	WORK		;W=FF,WORK=FF
	INCFSZ	WORK,W	;W=0 
	MOVLW	0xff		;W=0 -> OK,W=FF ->Error!
	MOVLW	0xaa		;W=AA
	MOVWF	WORK		;W=AA,WORK=AA
	BTFSC	WORK,4	;W=AA,bit4=0
	MOVLW	0xff		;W=AA->OK, W=FF ->Error!
	BTFSS	WORK,7	;W=AA,bit7=1
	MOVLW	0xff		;W=AA->OK, W=FF ->Error!
JMP	GOTO	JMP
	END
