;=======================================================================
;   Test Program for PIC16F508 Emulator
;   GP0-GP2 LED
;=======================================================================

	list      p=12F508
	#include <p12F508.inc>

	__CONFIG   _MCLRE_OFF & _CP_OFF & _WDT_OFF & _IntRC_OSC


;====== Variables ======================================================
VAL		EQU		0x08
NVAL		EQU		0x09
CNT		EQU		0x0A

;====== Program start ===================================================
	ORG		0x000             ; Start Address
	GOTO	start

;====== Initialize  =====================================================
init
	;Initialize GPIO
	MOVLW	0x08             ; GP3͓
	TRIS	GPIO
	CLRF	GPIO
	CLRF	CNT
	CLRF	VAL
	CLRF	NVAL
	RETLW	0

;====== PWMOUT  =======================================================
PwmOut
	MOVF	VAL,W
	SUBWF	NVAL,F
	INCF	VAL,1
	BSF		GPIO,0
Pwm1
	DECFSZ	VAL,f
	GOTO	Pwm1	
	BCF		GPIO,0
Pwm2
	DECFSZ	NVAL,f
	GOTO	Pwm2
	RETLW	0


;====== Main Program  ===================================================
start	
	CALL	init
main_1
	CALL	PwmOut
	INCF	CNT,F
	MOVF	CNT,W
	MOVWF	VAL
	GOTO	main_1
	END

