module mProgMem(fosc,reset,Qout,adr,dat,Qin,cmdClr);
	output fosc;
	input reset;
	output Qout;
	input [8:0] adr;
	output [15:0] dat;
	input Qin,cmdClr;
	wire fvail,fbusy;
	wire [15:0] dbus;
	reg [15:0] cmdReg;
	assign dat=cmdReg;
	assign Qout=fvail;
	FlashMem mem(adr,1'b0,fvail,dbus,fbusy,fosc);

	//Data Latch
	always@(posedge fosc or posedge reset) begin
		if(reset) begin
			cmdReg<=16'h0000;
		end else if(Qin) begin
			if(cmdClr)
				cmdReg<=16'h0000;
			else
				cmdReg<=dbus;
		end
	end
endmodule				
	
