`timescale 1 ps / 1 ps

module mProgMem(fosc,reset,adr,dat,Q,cmdClr);
	input fosc;
	input reset;
	input [8:0] adr;
	output [15:0] dat;
	input Q,cmdClr;
	wire [11:0] dbus;
	reg [15:0] cmdReg;
	
	assign dat=cmdReg;

	mFlashMem fmem(adr,dbus);
	//Data Latch
	always@(posedge fosc or posedge reset) begin
		if(reset) begin
			cmdReg<=16'h0000;
		end else if(Q) begin
			if(cmdClr)
				cmdReg<=16'h0000;
			else
				cmdReg<={4'h0,dbus};
		end
	end
endmodule				
	
